/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id$
 */
package org.enhydra.kelp.jbuilder.properties;

import org.enhydra.kelp.common.node.OtterProject;
import org.enhydra.kelp.jbuilder.node.PrimeProject;
import org.enhydra.kelp.common.wizard.conf.ConfPropertyPanel;
import org.enhydra.kelp.common.swing.SwingUtil;
import com.borland.primetime.properties.*;
import com.borland.primetime.help.HelpTopic;
import com.borland.jbuilder.node.*;
import com.borland.primetime.help.ZipHelpTopic;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.Beans;

public class ConfProjectPropertyPage extends PropertyPage {
  private OtterProject otterProject;
  private ConfPropertyPanel propertyPanel;
  private BorderLayout layoutMain;
  private final String HELP_PAGE = "file:../kelp1.2/doc/developer/jb-kelp.html#confproject";

  public ConfProjectPropertyPage(Object topic) {
    if (topic instanceof JBProject) {
      PrimeProject primeProject = null;
      otterProject = new PrimeProject((JBProject)topic);
      try {
        jbInit();
        pmInit();
      }
      catch(Exception e) {
        e.printStackTrace();
      }
    }
  }

  public void readProperties() {
    propertyPanel.readProperties();
    enableUI(true);
  }

  public HelpTopic getHelpTopic() {
    ZipHelpTopic t = new ZipHelpTopic( null, HELP_PAGE);
    return t;
  }

  public void writeProperties() {
    propertyPanel.writeProperties();
  }

  public ConfProjectPropertyPage() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void enableUI(boolean enabled) {
  }

  private void jbInit() throws Exception {
    layoutMain =
	    (BorderLayout) Beans.instantiate(getClass().getClassLoader(),
		      BorderLayout.class.getName());
    propertyPanel =
	    (ConfPropertyPanel) Beans.instantiate(getClass().getClassLoader(),
		      ConfPropertyPanel.class.getName());

    propertyPanel.setPreferredSize(new Dimension(0,0));
    this.setLayout(layoutMain);
    this.add(propertyPanel, BorderLayout.CENTER);
  }

  private void pmInit() {
    propertyPanel.setProject(otterProject);
  }

}
