/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 * $Id$
 */

package org.enhydra.kelp.jdeveloper.wizard.webapp;

// Kelp imports
import org.enhydra.kelp.KelpVersion;
import org.enhydra.kelp.common.wizard.codegen.WebAppUtil;
import org.enhydra.kelp.common.wizard.codegen.CodeGenUtil;
import org.enhydra.kelp.common.wizard.codegen.CodeGenException;
import org.enhydra.kelp.jdeveloper.wizard.AbstractCodeGenWizard;

// JDeveloper imports
import borland.jbuilder.addin.Context;
import borland.jbuilder.addin.IdeEnvironment;

// Standard imports
import javax.swing.JOptionPane;
import java.util.Vector;

/**
 * Class declaration
 *
 *
 * @author
 * @version %I%, %G%
 */
public class WebAppWizard extends AbstractCodeGenWizard {
    public String getDisplayName() {
      return WebAppUtil.getDisplayName();
    }

    /**
     * Method declaration
     *
     *
     * @param ide
     * @param context
     *
     * @see
     */
    public void invoke(IdeEnvironment ide, Context context) {
       CodeGenUtil util = null;
       if (isJava2(ide)) {
           try {
             util = new WebAppUtil();
             super.invoke(ide, context, util);
           } catch (CodeGenException e) {
               JOptionPane.showMessageDialog(ide.getIdeFrame(),
                                             e.getMessage());
           }
        }
    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    public String[] getSteps() {
        Vector steps = new Vector();
        String[] array = new String[0];
        if (KelpVersion.getEnhydraVersion().startsWith("4")) {
          steps.addElement(
             "Add a library to your project that contains j2ee.jar");
        }
        steps.addElement(
            "From the menu select Wizards | XMLC Compiler and click on Compile "
            + "to compile the welcome.html file a into DOM class.");
        steps.addElement(
            "Use Ctrl-F9 to make the project.");
        steps.addElement(
          "Deploy the project by selecting Wizards | Local Deployment.<BR>" +
          "Click on Deploy to process the configuration and descriptor templates.");
        steps.addElement(
            "Select the StartMultiServer.java program and press F9 launch the server.<BR>");
        steps.addElement(
            "From your browser enter: <BR>"+
            "<code>http://localhost:9000/welcome</code><BR>");
        array = (String[]) steps.toArray(array);
        steps.removeAllElements();
        return array;
    }

}
